## ns3 3.28+dfsg

=== ns-3.28/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

# python lib modules
from __future__ import print_function
import sys
import shutil
import types
import optparse
import os.path
import re
import shlex
import subprocess
import textwrap

from utils import read_config_file


# WAF modules
from waflib import Utils, Scripting, Configure, Build, Options, TaskGen, Context, Task, Logs, Errors
from waflib.Errors import WafError


# local modules
import wutils


# By default, all modules will be enabled, examples will be disabled,
# and tests will be disabled.
modules_enabled  = ['all_modules']
examples_enabled = False
tests_enabled    = False

# Compiler warning suppressions

# Bug 1868:  be conservative about -Wstrict-overflow for optimized builds
# on older compilers; it can generate spurious warnings.  
gcc_version_warn_strict_overflow = ('4', '8', '2')

# Bug 2181:  clang warnings about unused local typedefs and potentially
# evaluated expressions affecting darwin clang/LLVM version 7.0.0 (Xcode 7)
# or clang/LLVM version 3.6 or greater.  We must make this platform-specific.
darwin_clang_version_warn_unused_local_typedefs = ('7', '0', '0')
darwin_clang_version_warn_potentially_evaluated = ('7', '0', '0')
clang_version_warn_unused_local_typedefs = ('3', '6', '0')
clang_version_warn_potentially_evaluated = ('3', '6', '0')

# Get the information out of the NS-3 configuration file.
config_file_exists = False
(config_file_exists, modules_enabled, examples_enabled, tests_enabled) = read_config_file()

sys.path.insert(0, os.path.abspath('waf-tools'))
try:
    import cflags # override the build profiles from waf
finally:
    sys.path.pop(0)

cflags.profiles = {
    # profile name: [optimization_level, warnings_level, debug_level]
    'debug':     [0, 2, 3],
    'optimized': [3, 2, 1],
    'release':   [3, 2, 0],
    }
cflags.default_profile = 'debug'

Configure.autoconfig = 0

# the following two variables are used by the target "waf dist"
VERSION = open("VERSION", "rt").read().strip()
APPNAME = 'ns'

wutils.VERSION = VERSION
wutils.APPNAME = APPNAME

# we don't use VNUM anymore (see bug #1327 for details)
wutils.VNUM = None

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

def load_env():
    bld_cls = getattr(Utils.g_module, 'build_context', Utils.Context)
    bld_ctx = bld_cls()
    bld_ctx.load_dirs(os.path.abspath(os.path.join (srcdir,'..')),
                      os.path.abspath(os.path.join (srcdir,'..', blddir)))
    bld_ctx.load_envs()
    env = bld_ctx.get_env()
    return env

def get_files(base_dir):
    retval = []
    reference=os.path.dirname(base_dir)
    for root, dirs, files in os.walk(base_dir):
        if root.find('.hg') != -1:
            continue
        for file in files:
            if file.find('.hg') != -1:
                continue
            fullname = os.path.join(root,file)
            # we can't use os.path.relpath because it's new in python 2.6
            relname = fullname.replace(reference + '/','')
            retval.append([fullname,relname])
    return retval


def dist_hook():
    import tarfile
    shutil.rmtree("doc/html", True)
    shutil.rmtree("doc/latex", True)
    shutil.rmtree("nsc", True)

# Print the sorted list of module names in columns.
def print_module_names(names):
    # Sort the list of module names.
    names.sort()

    # Print the list of module names in 3 columns.
    i = 1
    for name in names:
        print(name.ljust(25), end=' ')
        if i == 3:
                print()
                i = 0
        i = i+1

    if i != 1:
        print()

# return types of some APIs differ in Python 2/3 (type string vs class bytes)
# This method will decode('utf-8') a byte object in Python 3, 
# and do nothing in Python 2
def maybe_decode(input):
    if sys.version_info < (3,):
        return input
    else:
        try:
            return input.decode('utf-8')
        except:
            sys.exc_clear()
            return input

def options(opt):
    # options provided by the modules
    opt.load('compiler_c')
    opt.load('compiler_cxx')
    opt.load('cflags')
    opt.load('gnu_dirs')

    opt.add_option('--check-config',
                   help=('Print the current configuration.'),
                   action="store_true", default=False,
                   dest="check_config")
    
    opt.add_option('--cwd',
                   help=('Set the working directory for a program.'),
                   action="store", type="string", default=None,
                   dest='cwd_launch')

    opt.add_option('--enable-gcov',
                   help=('Enable code coverage analysis.'
                         ' WARNING: this option only has effect '
                         'with the configure command.'),
                   action="store_true", default=False,
                   dest='enable_gcov')

    opt.add_option('--no-task-lines',
                   help=("Don't print task lines, i.e. messages saying which tasks are being executed by WAF."
                         "  Coupled with a single -v will cause WAF to output only the executed commands,"
                         " just like 'make' does by default."),
                   action="store_true", default=False,
                   dest='no_task_lines')

    opt.add_option('--lcov-report',
                   help=('Generate a code coverage report '
                         '(use this option at build time, not in configure)'),
                   action="store_true", default=False,
                   dest='lcov_report')

    opt.add_option('--run',
                   help=('Run a locally built program; argument can be a program name,'
                         ' or a command starting with the program name.'),
                   type="string", default='', dest='run')
    opt.add_option('--visualize',
                   help=('Modify --run arguments to enable the visualizer'),
                   action="store_true", default=False, dest='visualize')
    opt.add_option('--command-template',
                   help=('Template of the command used to run the program given by --run;'
                         ' It should be a shell command string containing %s inside,'
                         ' which will be replaced by the actual program.'),
                   type="string", default=None, dest='command_template')
    opt.add_option('--pyrun',
                   help=('Run a python program using locally built ns3 python module;'
                         ' argument is the path to the python program, optionally followed'
                         ' by command-line options that are passed to the program.'),
                   type="string", default='', dest='pyrun')
    opt.add_option('--valgrind',
                   help=('Change the default command template to run programs and unit tests with valgrind'),
                   action="store_true", default=False,
                   dest='valgrind')
    opt.add_option('--shell',
                   help=('DEPRECATED (run ./waf shell)'),
                   action="store_true", default=False,
                   dest='shell')
    opt.add_option('--enable-sudo',
                   help=('Use sudo to setup suid bits on ns3 executables.'),
                   dest='enable_sudo', action='store_true',
                   default=False)
    opt.add_option('--enable-tests',
                   help=('Build the ns-3 tests.'),
                   dest='enable_tests', action='store_true',
                   default=False)
    opt.add_option('--disable-tests',
                   help=('Do not build the ns-3 tests.'),
                   dest='disable_tests', action='store_true',
                   default=False)
    opt.add_option('--enable-examples',
                   help=('Build the ns-3 examples.'),
                   dest='enable_examples', action='store_true',
                   default=False)
    opt.add_option('--disable-examples',
                   help=('Do not build the ns-3 examples.'),
                   dest='disable_examples', action='store_true',
                   default=False)
    opt.add_option('--check',
                   help=('DEPRECATED (run ./test.py)'),
                   default=False, dest='check', action="store_true")
    opt.add_option('--enable-static',
                   help=('Compile NS-3 statically: works only on linux, without python'),
                   dest='enable_static', action='store_true',
                   default=False)
    opt.add_option('--enable-mpi',
                   help=('Compile NS-3 with MPI and distributed simulation support'),
                   dest='enable_mpi', action='store_true',
                   default=False)
    opt.add_option('--doxygen-no-build',
                   help=('Run doxygen to generate html documentation from source comments, '
                         'but do not wait for ns-3 to finish the full build.'),
                   action="store_true", default=False,
                   dest='doxygen_no_build')
    opt.add_option('--enable-des-metrics',
                   help=('Log all events in a json file with the name of the executable (which must call CommandLine::Parse(argc, argv)'),
                   action="store_true", default=False,
                   dest='enable_desmetrics')
    opt.add_option('--cxx-standard',
                   help=('Compile NS-3 with the given C++ standard'),
                   type='string', default='-std=c++11', dest='cxx_standard')

    # options provided in subdirectories
    opt.recurse('src')
    opt.recurse('bindings/python')
    opt.recurse('src/internet')
    opt.recurse('contrib')

def _check_compilation_flag(conf, flag, mode='cxx', linkflags=None):
    """
    Checks if the C++ compiler accepts a certain compilation flag or flags
    flag: can be a string or a list of strings
    """
    l = []
    if flag:
        l.append(flag)
    if isinstance(linkflags, list):
        l.extend(linkflags)
    else:
        if linkflags:
            l.append(linkflags)
    if len(l) > 1:
        flag_str = 'flags ' + ' '.join(l)
    else:
        flag_str = 'flag ' + ' '.join(l)
    if len(flag_str) > 28:
        flag_str = flag_str[:28] + "..."

    conf.start_msg('Checking for compilation %s support' % (flag_str,))
    env = conf.env.derive()

    retval = False
    if mode == 'cc':
        mode = 'c'

    if mode == 'cxx':
        env.append_value('CXXFLAGS', flag)
    else:
        env.append_value('CFLAGS', flag)

    if linkflags is not None:
        env.append_value("LINKFLAGS", linkflags)

    try:
        retval = conf.check(compiler=mode, fragment='int main() { return 0; }', features='c', env=env)
    except Errors.ConfigurationError:
        ok = False
    else:
        ok = (retval == True)
    conf.end_msg(ok)
    return ok


def report_optional_feature(conf, name, caption, was_enabled, reason_not_enabled):
    conf.env.append_value('NS3_OPTIONAL_FEATURES', [(name, caption, was_enabled, reason_not_enabled)])


def check_optional_feature(conf, name):
    for (name1, caption, was_enabled, reason_not_enabled) in conf.env.NS3_OPTIONAL_FEATURES:
        if name1 == name:
            return was_enabled
    raise KeyError("Feature %r not declared yet" % (name,))


# starting with waf 1.6, conf.check() becomes fatal by default if the
# test fails, this alternative method makes the test non-fatal, as it
# was in waf <= 1.5
def _check_nonfatal(conf, *args, **kwargs):
    try:
        return conf.check(*args, **kwargs)
    except conf.errors.ConfigurationError:
        return None

# Write a summary of optional features status
def print_config(env, phase='configure'):
    if phase == 'configure':
        profile = get_build_profile(env)
    else:
        profile = get_build_profile()
        
    print("---- Summary of optional NS-3 features:")
    print("%-30s: %s%s%s" % ("Build profile", Logs.colors('GREEN'),
                             profile, Logs.colors('NORMAL')))
    bld = wutils.bld

=== ns-3.28/contrib/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
from __future__ import print_function
import os, os.path
import sys
import shutil
import types
import warnings

from waflib import TaskGen, Task, Options, Build, Utils
from waflib.Errors import WafError
import wutils

try:
    set
except NameError:
    from sets import Set as set # Python 2.3 fallback

all_contrib_modules = []
for dirname in os.listdir('contrib'):
    if dirname.startswith('.') or dirname == 'CVS':
        continue
    path = os.path.join('contrib', dirname)
    if not os.path.isdir(path):
        continue
    if os.path.exists(os.path.join(path, 'wscript')):
        all_contrib_modules.append(dirname)
all_contrib_modules.sort()

def options(opt):
    for module in all_contrib_modules:
        opt.recurse(module, mandatory=False)

def configure(conf):
    for module in all_contrib_modules:
        conf.recurse(module, mandatory=False)

    ## Used to link the 'test-runner' program with all of ns-3 code
    conf.env['NS3_CONTRIBUTED_MODULES'] = ['ns3-' + module.split('/')[-1] for module in all_contrib_modules]


# we need the 'ns3module' waf "feature" to be created because code
# elsewhere looks for it to find the ns3 module objects.

def create_ns3_module(bld, name, dependencies=(), test=False):
    static = bool(bld.env.ENABLE_STATIC_NS3)
    # Create a separate library for this module.
    if static:
        module = bld(features='cxx cxxstlib ns3module')
    else:
        module = bld(features='cxx cxxshlib ns3module')
    module.target = '%s/ns%s-%s%s' % (bld.srcnode.path_from(module.path), wutils.VERSION,
                                       name, bld.env.BUILD_SUFFIX)
    linkflags = []
    cxxflags = []
    ccflags = []
    if not static:
        cxxflags = module.env['shlib_CXXFLAGS']
        ccflags = module.env['shlib_CXXFLAGS']
        # Turn on the link flags for shared libraries if we have the
        # proper compiler and platform.
        if module.env['CXX_NAME'] in ['gcc', 'icc'] and module.env['WL_SONAME_SUPPORTED']:
            # Get the module library name without any relative paths
            # at its beginning because all of the libraries will end
            # up in the same directory.
            module_library_name = module.env.cshlib_PATTERN % (os.path.basename(module.target),)
            linkflags = '-Wl,--soname=' + module_library_name
    cxxdefines = ["NS3_MODULE_COMPILATION"]
    ccdefines = ["NS3_MODULE_COMPILATION"]

    module.env.append_value('CXXFLAGS', cxxflags)
    module.env.append_value('CCFLAGS', ccflags)
    module.env.append_value('LINKFLAGS', linkflags)
    module.env.append_value('CXXDEFINES', cxxdefines)
    module.env.append_value('CCDEFINES', ccdefines)

    module.is_static = static
    module.vnum = wutils.VNUM
    # Add the proper path to the module's name.
    # Set the libraries this module depends on.  
    module.module_deps = list(dependencies)

    module.install_path = "${LIBDIR}"

    module.name = "ns3-" + name
    module.dependencies = dependencies
    # Initially create an empty value for this because the pcfile
    # writing task assumes every module has a uselib attribute.
    module.uselib = ''
    module.use = ['ns3-' + dep for dep in dependencies]
    module.test = test
    module.is_ns3_module = True
    module.ns3_dir_location = bld.path.path_from(bld.srcnode)

    module.env.append_value("INCLUDES", '#')

    module.pcfilegen = bld(features='ns3pcfile')
    module.pcfilegen.module = module.name
    
    return module

def create_ns3_module_test_library(bld, name):
    # Create an ns3 module for the test library that depends only on
    # the module being tested.
    library_name = name + "-test"
    library = bld.create_ns3_module(library_name, [name], test=True)
    library.features += " ns3testlib"

    # Modify attributes for the test library that are different from a
    # normal module.
    del library.is_ns3_module
    library.is_ns3_module_test_library = True
    library.module_name = 'ns3-' + name

    # Add this module and test library to the list.
    bld.env.append_value('NS3_MODULES_WITH_TEST_LIBRARIES', [(library.module_name, library.name)])

    # Set the include path from the build directory to modules. 
    relative_path_from_build_to_here = bld.path.path_from(bld.bldnode)
    include_flag = '-I' + relative_path_from_build_to_here
    library.env.append_value('CXXFLAGS', include_flag)
    library.env.append_value('CCFLAGS',  include_flag)

    return library

def create_obj(bld, *args):
    warnings.warn("(in %s) Use bld(...) call now, instead of bld.create_obj(...)" % str(bld.path),
                  DeprecationWarning, stacklevel=2)
    return bld(*args)


def ns3_python_bindings(bld):
    # this method is called from a module wscript, so remember bld.path is not bindings/python!
    module_abs_src_path = bld.path.abspath()
    module = os.path.basename(module_abs_src_path)
    env = bld.env
    env.append_value("MODULAR_BINDINGS_MODULES", "ns3-"+module)

    if Options.options.apiscan:
        return

    if not env['ENABLE_PYTHON_BINDINGS']:
        return

    bindings_dir = bld.path.find_dir("bindings")
    if bindings_dir is None or not os.path.exists(bindings_dir.abspath()):
        warnings.warn("(in %s) Requested to build modular python bindings, but apidefs dir not found "
                      "=> skipped the bindings." % str(bld.path),
                      Warning, stacklevel=2)
        return

    if ("ns3-%s" % (module,)) not in env.NS3_ENABLED_MODULES:
        #print "bindings for module %s which is not enabled, skip" % module
        return

    env.append_value('PYTHON_MODULES_BUILT', module)
    try:
        apidefs = env['PYTHON_BINDINGS_APIDEFS'].replace("-", "_")
    except AttributeError:
        # we likely got an empty list for env['PYTHON_BINDINGS_APIDEFS']
        return

    #debug = ('PYBINDGEN_DEBUG' in os.environ)
    debug = True # XXX
    source = [bld.srcnode.find_resource('bindings/python/ns3modulegen-modular.py'),
              bld.path.find_resource("bindings/modulegen__%s.py" % apidefs)]

    modulegen_customizations = bindings_dir.find_resource("modulegen_customizations.py")
    if modulegen_customizations is not None:
        source.append(modulegen_customizations)

    modulegen_local = bld.path.find_resource("bindings/modulegen_local.py")
    # the local customization file may or not exist
    if modulegen_local is not None:
        source.append("bindings/modulegen_local.py")

    module_py_name = module.replace('-', '_')
    module_target_dir = bld.srcnode.find_dir("bindings/python/ns").path_from(bld.path)

    # if bindings/<module>.py exists, it becomes the module frontend, and the C extension befomes _<module>
    if bld.path.find_resource("bindings/%s.py" % (module_py_name,)) is not None:
        bld(features='copy',
            source=("bindings/%s.py" % (module_py_name,)),
            target=('%s/%s.py' % (module_target_dir, module_py_name)))
        extension_name = '_%s' % (module_py_name,)
        bld.install_files('${PYTHONARCHDIR}/ns', ["bindings/%s.py" % (module_py_name,)])
    else:
        extension_name = module_py_name

    target = ['bindings/ns3module.cc', 'bindings/ns3module.h', 'bindings/ns3modulegen.log']
    #if not debug:
    #    target.append('ns3modulegen.log')

    argv = ['NS3_ENABLED_FEATURES=${FEATURES}',
            'GCC_RTTI_ABI_COMPLETE=${GCC_RTTI_ABI_COMPLETE}',
            '${PYTHON}']
    #if debug:
    #    argv.extend(["-m", "pdb"])
    
    argv.extend(['${SRC[0]}', module_abs_src_path, apidefs, extension_name, '${TGT[0]}'])

    argv.extend(['2>', '${TGT[2]}']) # 2> ns3modulegen.log

    features = []
    for (name, caption, was_enabled, reason_not_enabled) in env['NS3_OPTIONAL_FEATURES']:
        if was_enabled:
            features.append(name)

    bindgen = bld(features='command', source=source, target=target, command=argv)
    bindgen.env['FEATURES'] = ','.join(features)
    bindgen.dep_vars = ['FEATURES', "GCC_RTTI_ABI_COMPLETE"]
    bindgen.before = 'cxx'
    bindgen.after = 'gen_ns3_module_header'
    bindgen.name = "pybindgen(ns3 module %s)" % module
    bindgen.install_path = None

    # generate the extension module
    pymod = bld(features='cxx cxxshlib pyext')
    pymod.source = ['bindings/ns3module.cc']
    pymod.target = '%s/%s' % (module_target_dir, extension_name)
    pymod.name = 'ns3module_%s' % module
    pymod.use = ["%s" % mod for mod in pymod.env['NS3_ENABLED_MODULES']] #  Should be '"ns3-"+module', but see bug 1117
    if pymod.env['ENABLE_STATIC_NS3']:
        if sys.platform == 'darwin':
            pymod.env.append_value('LINKFLAGS', '-Wl,-all_load')
            for mod in pymod.usel:
                #mod = mod.split("--lib")[0]
                pymod.env.append_value('LINKFLAGS', '-l' + mod)
        else:
            pymod.env.append_value('LINKFLAGS', '-Wl,--whole-archive,-Bstatic')
            for mod in pymod.use:
                #mod = mod.split("--lib")[0]
                pymod.env.append_value('LINKFLAGS', '-l' + mod)
            pymod.env.append_value('LINKFLAGS', '-Wl,-Bdynamic,--no-whole-archive')
    defines = list(pymod.env['DEFINES'])
    defines.extend(['NS_DEPRECATED=', 'NS3_DEPRECATED_H'])
    if Options.platform == 'win32':
        try:
            defines.remove('_DEBUG') # causes undefined symbols on win32
        except ValueError:
            pass
    pymod.env['DEFINES'] = defines
    pymod.includes = '# bindings'
    pymod.install_path = '${PYTHONARCHDIR}/ns'

    # Workaround to a WAF bug, remove this when ns-3 upgrades to WAF > 1.6.10
    # https://www.nsnam.org/bugzilla/show_bug.cgi?id=1335
    # http://code.google.com/p/waf/issues/detail?id=1098
    if Utils.unversioned_sys_platform() == 'darwin':
        pymod.mac_bundle = True

    return pymod

def build(bld):
    bld.create_ns3_module = types.MethodType(create_ns3_module, bld)
    bld.create_ns3_module_test_library = types.MethodType(create_ns3_module_test_library, bld)
    bld.create_obj = types.MethodType(create_obj, bld)
    bld.ns3_python_bindings = types.MethodType(ns3_python_bindings, bld)
    
    # Remove these modules from the list of all modules.
    for not_built in bld.env['MODULES_NOT_BUILT']:

        if not_built in all_contrib_modules:
            all_contrib_modules.remove(not_built)

    bld.recurse(list(all_contrib_modules))

    for module in all_contrib_modules:
        modheader = bld(features='ns3moduleheader')
        modheader.module = module.split('/')[-1]

=== ns-3.28/src/wscript ===

## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
from __future__ import print_function
import os, os.path
import sys
import shutil
import types
import warnings

from waflib import TaskGen, Task, Options, Build, Utils
from waflib.Errors import WafError
import wutils

try:
    set
except NameError:
    from sets import Set as set # Python 2.3 fallback



all_modules = []
for dirname in os.listdir('src'):
    if dirname.startswith('.') or dirname == 'CVS':
        continue
    path = os.path.join('src', dirname)
    if not os.path.isdir(path):
        continue
    if os.path.exists(os.path.join(path, 'wscript')):
        all_modules.append(dirname)
all_modules.sort()



def options(opt):
    opt.add_option('--enable-rpath',
                   help=("Link programs with rpath"
                         " (normally not needed, see "
                         " --run and --shell; moreover, only works in some"
                         " specific platforms, such as Linux and Solaris)"),
                   action="store_true", dest='enable_rpath', default=False)
    
    opt.add_option('--enable-modules',
                   help=("Build only these modules (and dependencies)"),
                   dest='enable_modules')

    opt.load('boost', tooldir=['waf-tools'])

    for module in all_modules:
        opt.recurse(module, mandatory=False)

def configure(conf):
    conf.env['REQUIRED_BOOST_LIBS'] = []
    for module in all_modules:
        conf.recurse (module, name="required_boost_libs", mandatory=False)

    if conf.env['REQUIRED_BOOST_LIBS'] is not []:
        conf.load('boost')
        conf.check_boost(lib=' '.join (conf.env['REQUIRED_BOOST_LIBS']), mandatory=False)
        if not conf.env['LIB_BOOST']:
            conf.check_boost(lib=' '.join (conf.env['REQUIRED_BOOST_LIBS']), libpath="/usr/lib64", mandatory=False)
            if not conf.env['LIB_BOOST']:
                conf.env['LIB_BOOST'] = []

    # Append blddir to the module path before recursing into modules
    blddir = os.path.abspath(os.path.join(conf.bldnode.abspath(), conf.variant))
    conf.env.append_value('NS3_MODULE_PATH', blddir)

    for module in all_modules:
        conf.recurse(module, mandatory=False)

    # Remove duplicate path items
    conf.env['NS3_MODULE_PATH'] = wutils.uniquify_list(conf.env['NS3_MODULE_PATH'])

    if Options.options.enable_rpath:
        conf.env.append_value('RPATH', '-Wl,-rpath,%s' % (os.path.join(blddir),))

    ## Used to link the 'test-runner' program with all of ns-3 code
    conf.env['NS3_MODULES'] = ['ns3-' + module.split('/')[-1] for module in all_modules]



# we need the 'ns3module' waf "feature" to be created because code
# elsewhere looks for it to find the ns3 module objects.
@TaskGen.feature('ns3module')
def _add_test_code(module):
    pass

def create_ns3_module(bld, name, dependencies=(), test=False):
    static = bool(bld.env.ENABLE_STATIC_NS3)
    # Create a separate library for this module.
    if static:
        module = bld(features='cxx cxxstlib ns3module')
    else:
        module = bld(features='cxx cxxshlib ns3module')
    module.target = '%s/ns%s-%s%s' % (bld.srcnode.path_from(module.path), wutils.VERSION,
                                       name, bld.env.BUILD_SUFFIX)
    linkflags = []
    cxxflags = []
    ccflags = []
    if not static:
        cxxflags = module.env['shlib_CXXFLAGS']
        ccflags = module.env['shlib_CXXFLAGS']
        # Turn on the link flags for shared libraries if we have the
        # proper compiler and platform.
        if module.env['CXX_NAME'] in ['gcc', 'icc'] and module.env['WL_SONAME_SUPPORTED']:
            # Get the module library name without any relative paths
            # at its beginning because all of the libraries will end
            # up in the same directory.
            module_library_name = module.env.cshlib_PATTERN % (os.path.basename(module.target),)
            linkflags = '-Wl,--soname=' + module_library_name
    cxxdefines = ["NS3_MODULE_COMPILATION"]
    ccdefines = ["NS3_MODULE_COMPILATION"]

    module.env.append_value('CXXFLAGS', cxxflags)
    module.env.append_value('CCFLAGS', ccflags)
    module.env.append_value('LINKFLAGS', linkflags)
    module.env.append_value('CXXDEFINES', cxxdefines)
    module.env.append_value('CCDEFINES', ccdefines)

    module.is_static = static
    module.vnum = wutils.VNUM
    # Add the proper path to the module's name.
    # Set the libraries this module depends on.  
    module.module_deps = list(dependencies)

    module.install_path = "${LIBDIR}"

    module.name = "ns3-" + name
    module.dependencies = dependencies
    # Initially create an empty value for this because the pcfile
    # writing task assumes every module has a uselib attribute.
    module.uselib = ''
    module.use = ['ns3-' + dep for dep in dependencies]
    module.test = test
    module.is_ns3_module = True
    module.ns3_dir_location = bld.path.path_from(bld.srcnode)

    module.env.append_value("INCLUDES", '#')

    module.pcfilegen = bld(features='ns3pcfile')
    module.pcfilegen.module = module.name
    
    return module

@TaskGen.feature("ns3testlib")
@TaskGen.before_method("apply_incpaths")
def apply_incpaths_ns3testlib(self):
    if not self.source:
        return
    testdir = self.source[-1].parent.path_from(self.bld.srcnode)
    self.env.append_value("DEFINES", 'NS_TEST_SOURCEDIR="%s"' % (testdir,))


def create_ns3_module_test_library(bld, name):
    # Create an ns3 module for the test library that depends only on
    # the module being tested.
    library_name = name + "-test"
    library = bld.create_ns3_module(library_name, [name], test=True)
    library.features += " ns3testlib"

    # Modify attributes for the test library that are different from a
    # normal module.
    del library.is_ns3_module
    library.is_ns3_module_test_library = True
    library.module_name = 'ns3-' + name

    # Add this module and test library to the list.
    bld.env.append_value('NS3_MODULES_WITH_TEST_LIBRARIES', [(library.module_name, library.name)])

    # Set the include path from the build directory to modules. 
    relative_path_from_build_to_here = bld.path.path_from(bld.bldnode)
    include_flag = '-I' + relative_path_from_build_to_here
    library.env.append_value('CXXFLAGS', include_flag)
    library.env.append_value('CCFLAGS',  include_flag)

    return library

def create_obj(bld, *args):
    warnings.warn("(in %s) Use bld(...) call now, instead of bld.create_obj(...)" % str(bld.path),
                  DeprecationWarning, stacklevel=2)
    return bld(*args)


def ns3_python_bindings(bld):

    # this method is called from a module wscript, so remember bld.path is not bindings/python!
    module_abs_src_path = bld.path.abspath()
    module = os.path.basename(module_abs_src_path)
    env = bld.env
    env.append_value("MODULAR_BINDINGS_MODULES", "ns3-"+module)

    if Options.options.apiscan:
        return

    if not env['ENABLE_PYTHON_BINDINGS']:
        return

    bindings_dir = bld.path.find_dir("bindings")
    if bindings_dir is None or not os.path.exists(bindings_dir.abspath()):
        warnings.warn("(in %s) Requested to build modular python bindings, but apidefs dir not found "
                      "=> skipped the bindings." % str(bld.path),
                      Warning, stacklevel=2)
        return

    if ("ns3-%s" % (module,)) not in env.NS3_ENABLED_MODULES:
        #print "bindings for module %s which is not enabled, skip" % module
        return

    env.append_value('PYTHON_MODULES_BUILT', module)
    try:
        apidefs = env['PYTHON_BINDINGS_APIDEFS'].replace("-", "_")
    except AttributeError:
        # we likely got an empty list for env['PYTHON_BINDINGS_APIDEFS']
        return

    #debug = ('PYBINDGEN_DEBUG' in os.environ)
    debug = True # XXX
    source = [bld.srcnode.find_resource('bindings/python/ns3modulegen-modular.py'),
              bld.path.find_resource("bindings/modulegen__%s.py" % apidefs)]

    modulegen_customizations = bindings_dir.find_resource("modulegen_customizations.py")
    if modulegen_customizations is not None:
        source.append(modulegen_customizations)

    modulegen_local = bld.path.find_resource("bindings/modulegen_local.py")
    # the local customization file may or not exist
    if modulegen_local is not None:
        source.append("bindings/modulegen_local.py")

    module_py_name = module.replace('-', '_')
    module_target_dir = bld.srcnode.find_dir("bindings/python/ns").path_from(bld.path)

    # if bindings/<module>.py exists, it becomes the module frontend, and the C extension befomes _<module>
    if bld.path.find_resource("bindings/%s.py" % (module_py_name,)) is not None:
        bld(features='copy',
            source=("bindings/%s.py" % (module_py_name,)),
            target=('%s/%s.py' % (module_target_dir, module_py_name)))
        extension_name = '_%s' % (module_py_name,)
        bld.install_files('${PYTHONARCHDIR}/ns', ["bindings/%s.py" % (module_py_name,)])
    else:
        extension_name = module_py_name

    target = ['bindings/ns3module.cc', 'bindings/ns3module.h', 'bindings/ns3modulegen.log']
    #if not debug:
    #    target.append('ns3modulegen.log')

    argv = ['NS3_ENABLED_FEATURES=${FEATURES}',
            'GCC_RTTI_ABI_COMPLETE=${GCC_RTTI_ABI_COMPLETE}',
            '${PYTHON}']
    #if debug:
    #    argv.extend(["-m", "pdb"])
    
    argv.extend(['${SRC[0]}', module_abs_src_path, apidefs, extension_name, '${TGT[0]}'])

    argv.extend(['2>', '${TGT[2]}']) # 2> ns3modulegen.log

    features = []
    for (name, caption, was_enabled, reason_not_enabled) in env['NS3_OPTIONAL_FEATURES']:
        if was_enabled:
            features.append(name)

    bindgen = bld(features='command', source=source, target=target, command=argv)
    bindgen.env['FEATURES'] = ','.join(features)
    bindgen.dep_vars = ['FEATURES', "GCC_RTTI_ABI_COMPLETE"]
    bindgen.before = 'cxx'
    bindgen.after = 'gen_ns3_module_header'
    bindgen.name = "pybindgen(ns3 module %s)" % module
    bindgen.install_path = None

    # generate the extension module
    pymod = bld(features='cxx cxxshlib pyext')
    pymod.source = ['bindings/ns3module.cc']
    pymod.target = '%s/%s' % (module_target_dir, extension_name)
    pymod.name = 'ns3module_%s' % module
    pymod.use = ["%s" % mod for mod in pymod.env['NS3_ENABLED_MODULES']] #  Should be '"ns3-"+module', but see bug 1117
    if pymod.env['ENABLE_STATIC_NS3']:
        if sys.platform == 'darwin':
            pymod.env.append_value('LINKFLAGS', '-Wl,-all_load')
            for mod in pymod.usel:
                #mod = mod.split("--lib")[0]
                pymod.env.append_value('LINKFLAGS', '-l' + mod)
        else:
            pymod.env.append_value('LINKFLAGS', '-Wl,--whole-archive,-Bstatic')
            for mod in pymod.use:
                #mod = mod.split("--lib")[0]
                pymod.env.append_value('LINKFLAGS', '-l' + mod)
            pymod.env.append_value('LINKFLAGS', '-Wl,-Bdynamic,--no-whole-archive')
    defines = list(pymod.env['DEFINES'])
    defines.extend(['NS_DEPRECATED=', 'NS3_DEPRECATED_H'])
    if Options.platform == 'win32':
        try:
            defines.remove('_DEBUG') # causes undefined symbols on win32
        except ValueError:
            pass
    pymod.env['DEFINES'] = defines
    pymod.includes = '# bindings'
    pymod.install_path = '${PYTHONARCHDIR}/ns'

    # Workaround to a WAF bug, remove this when ns-3 upgrades to WAF > 1.6.10
    # https://www.nsnam.org/bugzilla/show_bug.cgi?id=1335
    # http://code.google.com/p/waf/issues/detail?id=1098
    if Utils.unversioned_sys_platform() == 'darwin':
        pymod.mac_bundle = True

    return pymod


def build(bld):
    bld.create_ns3_module = types.MethodType(create_ns3_module, bld)
    bld.create_ns3_module_test_library = types.MethodType(create_ns3_module_test_library, bld)
    bld.create_obj = types.MethodType(create_obj, bld)

=== ns-3.28/bindings/python/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
from __future__ import print_function
import types
import re
import os
import subprocess
import shutil
import sys

from waflib import Task, Options, Configure, TaskGen, Logs, Build, Utils, Errors
from waflib.Errors import WafError

# feature  = TaskGen.feature
# after = TaskGen.after

# https://github.com/gjcarneiro/pybindgen
REQUIRED_PYBINDGEN_VERSION = '0.17.0.post58+ngcf00cc0'
REQUIRED_PYGCCXML_VERSION = (1, 9, 0)
REQUIRED_CASTXML_VERSION = '0.1'

RUN_ME=-3

# return types of some APIs differ in Python 2/3 (type string vs class bytes)
# This method will decode('utf-8') a byte object in Python 3,
# and do nothing in Python 2
def maybe_decode(input):
    if sys.version_info < (3,):
        return input
    else:
        try: 
            return input.decode('utf-8')
        except:
            sys.exc_clear()
            return input

def add_to_python_path(path):
    if os.environ.get('PYTHONPATH', ''):
        os.environ['PYTHONPATH'] = path + os.pathsep + os.environ.get('PYTHONPATH')
    else:
        os.environ['PYTHONPATH'] = path

def set_pybindgen_pythonpath(env):
    if env['WITH_PYBINDGEN']:
        add_to_python_path(env['WITH_PYBINDGEN'])


def options(opt):
    opt.load('python')
    opt.add_option('--disable-python',
                   help=("Don't build Python bindings."),
                   action="store_true", default=False,
                   dest='python_disable')
    opt.add_option('--apiscan',
                   help=("Rescan the API for the indicated module(s), for Python bindings.  "
                         "Needs working CastXML / pygccxml environment.  "
                         "The metamodule 'all' expands to all available ns-3 modules."),
                   default=None, dest='apiscan', metavar="MODULE[,MODULE...]")
    opt.add_option('--with-pybindgen',
                   help=('Path to an existing pybindgen source tree to use.'),
                   default=None,
                   dest='with_pybindgen', type="string")
    opt.add_option('--with-python',
                   help=('Path to the Python interpreter to use.'),
                   default=None, dest='with_python', type="string")
    opt.add_option('--no32bit-scan',
                   help=("Don't scan for the 32-bit variant of the bindings on 64-bit platforms."),
                   action="store_true", default=False,
                   dest='no32bit_scan')


def split_version(version):
    if (re.search ('post', version)):
        # Version format such as '0.17.0.post58+ngcf00cc0'
        ver = re.split('[.+]', version)[:4]
        return (int(ver[0]), int(ver[1]), int(ver[2]), int(ver[3].split('post')[1]))
    else:
        # Version format such as '0.18.0'
        ver = re.split('[.]', version)[:3]
        return (int(ver[0]), int(ver[1]), int(ver[2]), 0)


def configure(conf):
    conf.env['ENABLE_PYTHON_BINDINGS'] = False
    if Options.options.python_disable:
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "disabled by user request")
        return
    # Disable python in static builds (bug #1253)
    if ((conf.env['ENABLE_STATIC_NS3']) or \
      (conf.env['ENABLE_SHARED_AND_STATIC_NS3'])):
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "bindings incompatible with static build")
        return

    enabled_modules = list(conf.env['NS3_ENABLED_MODULES'])
    enabled_modules.sort()
    available_modules = list(conf.env['NS3_MODULES'])
    available_modules.sort()
    all_modules_enabled = (enabled_modules == available_modules)

    conf.load('misc', tooldir=['waf-tools'])

    if sys.platform == 'cygwin':
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "unsupported platform 'cygwin'")
        Logs.warn("Python is not supported in CygWin environment.  Try MingW instead.")
        return


    ## Check for Python

    if Options.options.with_python is not None:
        conf.env.PYTHON = Options.options.with_python

    try:
        conf.load('python')
    except Errors.ConfigurationError as ex:
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "The python interpreter was not found")
        return
    try:
        conf.check_python_version((2,3))
    except Errors.ConfigurationError as ex:
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "The python found version is too low (2.3 required)")
        return
    try:
        conf.check_python_headers()
    except Errors.ConfigurationError as ex:
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "Python library or headers missing")
        return

    # stupid Mac OSX Python wants to build extensions as "universal
    # binaries", i386, x86_64, and ppc, but this way the type
    # __uint128_t is not available.  We need to disable the multiarch
    # crap by removing the -arch parameters.
    for flags_var in ["CFLAGS_PYEXT", "CFLAGS_PYEMBED", "CXXFLAGS_PYEMBED",
                      "CXXFLAGS_PYEXT", "LINKFLAGS_PYEMBED", "LINKFLAGS_PYEXT"]:
        flags = conf.env[flags_var]
        i = 0
        while i < len(flags):
            if flags[i] == '-arch':
                del flags[i]
                del flags[i]
                continue
            i += 1
        conf.env[flags_var] = flags

    # -fvisibility=hidden optimization
    if (conf.env['CXX_NAME'] == 'gcc' and [int(x) for x in conf.env['CC_VERSION']] >= [4,0,0]
        and conf.check_compilation_flag('-fvisibility=hidden')):
        conf.env.append_value('CXXFLAGS_PYEXT', '-fvisibility=hidden')
        conf.env.append_value('CCFLAGS_PYEXT', '-fvisibility=hidden')

    if conf.check_compilation_flag('-Wno-array-bounds'):
        conf.env.append_value('CXXFLAGS_PYEXT', '-Wno-array-bounds')

    # Check for the location of pybindgen
    if Options.options.with_pybindgen is not None:
        if os.path.isdir(Options.options.with_pybindgen):
            conf.msg("Checking for pybindgen location", ("%s (given)" % Options.options.with_pybindgen))
            conf.env['WITH_PYBINDGEN'] = os.path.abspath(Options.options.with_pybindgen)
    else:
        # ns-3-dev uses ../pybindgen, while ns-3 releases use ../REQUIRED_PYBINDGEN_VERSION
        pybindgen_dir = os.path.join('..', "pybindgen")
        pybindgen_release_str = "pybindgen-" + REQUIRED_PYBINDGEN_VERSION
        pybindgen_release_dir = os.path.join('..', pybindgen_release_str)
        if os.path.isdir(pybindgen_dir):
            conf.msg("Checking for pybindgen location", ("%s (guessed)" % pybindgen_dir))
            conf.env['WITH_PYBINDGEN'] = os.path.abspath(pybindgen_dir)
        elif os.path.isdir(pybindgen_release_dir):
            conf.msg("Checking for pybindgen location", ("%s (guessed)" % pybindgen_release_dir))
            conf.env['WITH_PYBINDGEN'] = os.path.abspath(pybindgen_release_dir)
        del pybindgen_dir
        del pybindgen_release_dir
    if not conf.env['WITH_PYBINDGEN']:
        conf.msg("Checking for pybindgen location", False)

    # Check for pybindgen

    set_pybindgen_pythonpath(conf.env)

    try:
        conf.check_python_module('pybindgen')
    except Errors.ConfigurationError:
        Logs.warn("pybindgen missing => no python bindings")
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "PyBindGen missing")
        return
    else:
        out = subprocess.Popen([conf.env['PYTHON'][0], "-c",
                                "import pybindgen.version; "
                                "print(pybindgen.__version__)"],
                                stdout=subprocess.PIPE).communicate()[0]
        pybindgen_version = maybe_decode(out.strip())
        conf.msg('Checking for pybindgen version', pybindgen_version)
        if not (split_version(pybindgen_version) >= split_version(REQUIRED_PYBINDGEN_VERSION)):
            Logs.warn("pybindgen (found %r), (need %r)" %
                      (pybindgen_version, REQUIRED_PYBINDGEN_VERSION))
            conf.report_optional_feature("python", "Python Bindings", False,
                                         "PyBindGen version not correct and newer version could not be retrieved")
            return


    def test(t1, t2):
        test_program = '''
#include <stdint.h>
#include <vector>

int main ()
{
   std::vector< %(type1)s > t = std::vector< %(type2)s > ();
   return 0;
}
''' % dict(type1=t1, type2=t2)

        try:
            ret = conf.check(compiler='cxx', fragment=test_program, features='cxx')
        except Errors.ConfigurationError:
            ret = False
        conf.msg('Checking for types %s and %s equivalence' % (t1, t2), (ret and 'no' or 'yes'))
        return ret

    uint64_is_long = test("uint64_t", "unsigned long")
    uint64_is_long_long = test("uint64_t", "unsigned long long")

    if uint64_is_long:
        conf.env['PYTHON_BINDINGS_APIDEFS'] = 'gcc-LP64'
    elif uint64_is_long_long:
        conf.env['PYTHON_BINDINGS_APIDEFS'] = 'gcc-ILP32'
    else:
        conf.env['PYTHON_BINDINGS_APIDEFS'] = None
    if conf.env['PYTHON_BINDINGS_APIDEFS'] is None:
        msg = 'none available'
    else:
        msg = conf.env['PYTHON_BINDINGS_APIDEFS']

    conf.msg('Checking for the apidefs that can be used for Python bindings', msg)

    if conf.env['PYTHON_BINDINGS_APIDEFS'] is None:
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "No apidefs are available that can be used in this system")
        return


    ## If all has gone well, we finally enable the Python bindings
    conf.env['ENABLE_PYTHON_BINDINGS'] = True
    conf.report_optional_feature("python", "Python Bindings", True, None)


    # check cxxabi stuff (which Mac OS X Lion breaks)
    fragment = r"""
# include <cxxabi.h>
int main ()
{
   const abi::__si_class_type_info *_typeinfo  __attribute__((unused)) = NULL;
   return 0;
}
"""
    gcc_rtti_abi = conf.check_nonfatal(fragment=fragment, msg="Checking for internal GCC cxxabi",
                                       okmsg="complete", errmsg='incomplete',
                                       mandatory=False)
    conf.env["GCC_RTTI_ABI_COMPLETE"] = str(bool(gcc_rtti_abi))



    ## Check for pygccxml
    try:
        conf.check_python_module('pygccxml')
    except Errors.ConfigurationError:
        conf.report_optional_feature("castxml", "Python API Scanning Support", False,
                                     "Missing 'pygccxml' Python module")
        return

    try:
        import pygccxml as pygccxml_imported
        pygccxml_version_str = pygccxml_imported.__version__
    except (ImportError, AttributeError):
        Logs.warn("pygccxml version cannot be determined")
        conf.report_optional_feature("castxml", "Python API Scanning Support", False,
                                     "pygccxml Python module version is unknown")
        return

    # Bug 2013:  pygccxml versions > 1.0.0 prepend a 'v' to version number
    pygccxml_version_str = pygccxml_version_str.lstrip('v')
    pygccxml_version = tuple([int(x) for x in pygccxml_version_str.split('.')])
    conf.msg('Checking for pygccxml version', pygccxml_version_str)
    if not (pygccxml_version >= REQUIRED_PYGCCXML_VERSION):
        Logs.warn("pygccxml (found %s) is too old (need %s) => "
                "automatic scanning of API definitions will not be possible" %
                (pygccxml_version_str,
                 '.'.join([str(x) for x in REQUIRED_PYGCCXML_VERSION])))
        conf.report_optional_feature("castxml", "Python API Scanning Support", False,
                                     "pygccxml Python module too old")
        return


    ## Check castxml version
    try:

=== ns-3.28/doc/models/Makefile ===
EPSTOPDF = epstopdf
DIA = dia
CONVERT = convert

SRC = ../../src
# Temporary source directory, for build
SOURCETEMP = source-temp
FIGURES = $(SOURCETEMP)/figures

# list all model library .rst files that need to be copied to $SOURCETEMP
SOURCES = \
	source/conf.py \
	source/_static \
	source/index.rst \
	source/replace.txt \
	source/organization.rst \
	source/internet-models.rst \
	source/network.rst \
	source/emulation-overview.rst \
	source/traffic-control.rst \
	$(SRC)/antenna/doc/source/antenna.rst \
	$(SRC)/antenna/doc/source/antenna-design.rst \
	$(SRC)/antenna/doc/source/antenna-user.rst \
	$(SRC)/antenna/doc/source/antenna-testing.rst \
	$(SRC)/aodv/doc/aodv.rst \
	$(SRC)/applications/doc/applications.rst \
	$(SRC)/bridge/doc/bridge.rst \
	$(SRC)/brite/doc/brite.rst \
	$(SRC)/buildings/doc/source/buildings.rst \
	$(SRC)/buildings/doc/source/buildings-design.rst \
	$(SRC)/buildings/doc/source/buildings-user.rst \
	$(SRC)/buildings/doc/source/buildings-testing.rst \
	$(SRC)/buildings/doc/source/buildings-references.rst \
	$(SRC)/click/doc/click.rst \
	$(SRC)/csma/doc/csma.rst \
	$(SRC)/dsdv/doc/dsdv.rst \
	$(SRC)/dsr/doc/dsr.rst \
	$(SRC)/mpi/doc/distributed.rst \
	$(SRC)/energy/doc/energy.rst \
	$(SRC)/fd-net-device/doc/fd-net-device.rst \
	$(SRC)/tap-bridge/doc/tap.rst \
	$(SRC)/mesh/doc/source/mesh.rst \
	$(SRC)/mesh/doc/source/mesh-user.rst \
	$(SRC)/mesh/doc/source/mesh-design.rst \
	$(SRC)/mesh/doc/source/mesh-references.rst \
	$(SRC)/mesh/doc/source/mesh-testing.rst \
	$(SRC)/lte/doc/source/lte.rst \
	$(SRC)/lte/doc/source/lte-user.rst \
	$(SRC)/lte/doc/source/lte-design.rst \
	$(SRC)/lte/doc/source/lte-testing.rst \
	$(SRC)/lte/doc/source/lte-profiling.rst \
	$(SRC)/lte/doc/source/lte-references.rst \
	$(SRC)/propagation/doc/propagation.rst \
	$(SRC)/network/doc/network-overview.rst \
	$(SRC)/network/doc/packets.rst \
	$(SRC)/network/doc/error-model.rst \
	$(SRC)/network/doc/sockets-api.rst \
	$(SRC)/network/doc/simple.rst \
	$(SRC)/network/doc/queue.rst \
	$(SRC)/network/doc/queue-limits.rst \
	$(SRC)/nix-vector-routing/doc/nix-vector-routing.rst \
	$(SRC)/internet/doc/internet-stack.rst \
	$(SRC)/internet/doc/ipv4.rst \
	$(SRC)/internet/doc/ipv6.rst \
	$(SRC)/internet/doc/routing-overview.rst \
	$(SRC)/internet/doc/tcp.rst \
	$(SRC)/internet/doc/udp.rst \
	$(SRC)/internet-apps/doc/internet-apps.rst \
	$(SRC)/mobility/doc/mobility.rst \
	$(SRC)/olsr/doc/olsr.rst \
	$(SRC)/openflow/doc/openflow-switch.rst \
	$(SRC)/point-to-point/doc/point-to-point.rst \
	$(SRC)/wifi/doc/source/wifi.rst \
	$(SRC)/wifi/doc/source/wifi-design.rst \
	$(SRC)/wifi/doc/source/wifi-user.rst \
	$(SRC)/wifi/doc/source/wifi-testing.rst \
	$(SRC)/wifi/doc/source/wifi-references.rst \
	$(SRC)/wimax/doc/wimax.rst \
	$(SRC)/uan/doc/uan.rst \
	$(SRC)/topology-read/doc/topology.rst \
	$(SRC)/traffic-control/doc/traffic-control-layer.rst \
	$(SRC)/traffic-control/doc/queue-discs.rst \
	$(SRC)/traffic-control/doc/pfifo-fast.rst \
	$(SRC)/traffic-control/doc/fifo.rst \
	$(SRC)/traffic-control/doc/tbf.rst \
	$(SRC)/traffic-control/doc/red.rst \
	$(SRC)/traffic-control/doc/codel.rst \
	$(SRC)/traffic-control/doc/fq-codel.rst \
	$(SRC)/traffic-control/doc/pie.rst \
	$(SRC)/traffic-control/doc/mq.rst \
	$(SRC)/spectrum/doc/spectrum.rst \
	$(SRC)/netanim/doc/animation.rst \
	$(SRC)/flow-monitor/doc/flow-monitor.rst \
	$(SRC)/wave/doc/wave.rst \
	$(SRC)/sixlowpan/doc/sixlowpan.rst \
	$(SRC)/lr-wpan/doc/lr-wpan.rst \

# list all model library figure files that need to be copied to 
# $SOURCETEMP/figures.  For each figure to be included in all
# documentation formats (html, latex...) the following formats are supported: 
#  1) a single .dia file (preferred option, because it can be edited)
#  2) a single .eps file
#  3) both a .pdf and .png file
SOURCEFIGS = \
	figures/testbed.dia \
	figures/emulated-channel.dia \
	$(SRC)/antenna/doc/source/figures/antenna-coordinate-system.dia	\
	$(SRC)/network/doc/packet.dia \
	$(SRC)/network/doc/node.dia \
	$(SRC)/network/doc/buffer.dia \
	$(SRC)/network/doc/sockets-overview.dia \
	$(SRC)/internet/doc/internet-node-send.dia \
	$(SRC)/internet/doc/internet-node-recv.dia \
	$(SRC)/internet/doc/routing.dia \
	$(SRC)/internet/doc/routing-specialization.dia \
	$(SRC)/internet/doc/figures/tcp-state-machine.png \
	$(SRC)/wifi/doc/source/figures/WifiArchitecture.dia \
	$(SRC)/wifi/doc/source/figures/snir.dia \
	$(SRC)/wifi/doc/source/figures/clear-channel.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-n.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ac.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ax.eps \
	$(SRC)/wimax/doc/WimaxArchitecture.dia \
	$(SRC)/lte/doc/source/figures/epc-ctrl-arch.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul.dia \
	$(SRC)/lte/doc/source/figures/epc-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/epc-topology.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-x2-enhanced.dia \
	$(SRC)/lte/doc/source/figures/eutran-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/ff-example.dia \
	$(SRC)/lte/doc/source/figures/ff-mac-saps.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-enb-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-ue-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-handover-seq-diagram.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack.dia \
	$(SRC)/lte/doc/source/figures/lte-interference-test-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-subframe-structure.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-interface.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-architecture.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-processes-scheme.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-consumer.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-motion.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1-hys.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-timeline.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-handover-target-scenario.dia \
	$(SRC)/lte/doc/source/figures/lena-dual-stripe.eps \
	$(SRC)/lte/doc/source/figures/lte-mcs-index.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase1.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase2.eps \
	$(SRC)/lte/doc/source/figures/runningTime10s.eps \
	$(SRC)/lte/doc/source/figures/epcRunningTime.eps \
	$(SRC)/lte/doc/source/figures/propagationModel.eps \
	$(SRC)/lte/doc/source/figures/simulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcSimulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcEutranRunningTime.eps \
	$(SRC)/lte/doc/source/figures/profiling-memory.eps \
	$(SRC)/lte/doc/source/figures/lte-rlc-implementation-model.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-entity-saps.dia \
	$(SRC)/lte/doc/source/figures/ca-rrc-reconf.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-enb-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-ue-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/lte-strongest-cell-handover-algorithm.eps \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.pdf \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.png \
	$(SRC)/lte/doc/source/figures/helpers.pdf \
	$(SRC)/lte/doc/source/figures/helpers.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.pdf \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration.pdf \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration-handover.pdf \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration-handover.png \
	$(SRC)/lte/doc/source/figures/nas-attach.pdf \
	$(SRC)/lte/doc/source/figures/nas-attach.png \
	$(SRC)/lte/doc/source/figures/ca-downlink-bsr.pdf \
	$(SRC)/lte/doc/source/figures/ca-downlink-bsr.png \
	$(SRC)/lte/doc/source/figures/ca-setup-radio-bearer.pdf \
	$(SRC)/lte/doc/source/figures/ca-setup-radio-bearer.png \
	$(SRC)/lte/doc/source/figures/lte-enb-rrc-states.pdf \
	$(SRC)/lte/doc/source/figures/lte-enb-rrc-states.png \
	$(SRC)/lte/doc/source/figures/lte-ue-rrc-states.pdf \
	$(SRC)/lte/doc/source/figures/lte-ue-rrc-states.png \
	$(SRC)/lte/doc/source/figures/fading_pedestrian.pdf \
	$(SRC)/lte/doc/source/figures/fading_pedestrian.png \
	$(SRC)/lte/doc/source/figures/fading_vehicular.pdf \
	$(SRC)/lte/doc/source/figures/fading_vehicular.png \
	$(SRC)/lte/doc/source/figures/fading_urban_3kmph.pdf \
	$(SRC)/lte/doc/source/figures/fading_urban_3kmph.png \
	$(SRC)/lte/doc/source/figures/fr-enhanced-fractional-frequency-reuse-scheme.dia \
	$(SRC)/lte/doc/source/figures/fr-full-frequency-reuse-scheme.dia \
	$(SRC)/lte/doc/source/figures/fr-hard-frequency-reuse-scheme.dia \
	$(SRC)/lte/doc/source/figures/fr-soft-fractional-frequency-reuse-scheme.dia \
	$(SRC)/lte/doc/source/figures/fr-soft-frequency-reuse-scheme-v1.dia \
	$(SRC)/lte/doc/source/figures/fr-soft-frequency-reuse-scheme-v2.dia \
	$(SRC)/lte/doc/source/figures/fr-strict-frequency-reuse-scheme.dia \
	$(SRC)/lte/doc/source/figures/ffr-distributed-scheme.dia \
	$(SRC)/lte/doc/source/figures/lte-fr-soft-1-rem.png \
	$(SRC)/lte/doc/source/figures/lte-fr-soft-1-rem.pdf \
	$(SRC)/lte/doc/source/figures/lte-ffr-soft-2-spectrum-trace.png \
	$(SRC)/lte/doc/source/figures/lte-ffr-soft-2-spectrum-trace.pdf \
	$(SRC)/lte/doc/source/figures/lte-fr-hard-1-rem.png \
	$(SRC)/lte/doc/source/figures/lte-fr-hard-1-rem.pdf \
	$(SRC)/lte/doc/source/figures/lte-fr-hard-2-rem.png \
	$(SRC)/lte/doc/source/figures/lte-fr-hard-2-rem.pdf \
	$(SRC)/lte/doc/source/figures/lte-fr-hard-3-rem.png \
	$(SRC)/lte/doc/source/figures/lte-fr-hard-3-rem.pdf \
	$(SRC)/lte/doc/source/figures/MCS_1_4.pdf \
	$(SRC)/lte/doc/source/figures/MCS_1_4.png \
	$(SRC)/lte/doc/source/figures/MCS_5_8.pdf \
	$(SRC)/lte/doc/source/figures/MCS_5_8.png \
	$(SRC)/lte/doc/source/figures/MCS_9_12.pdf \
	$(SRC)/lte/doc/source/figures/MCS_9_12.png \
	$(SRC)/lte/doc/source/figures/MCS_13_16.pdf \
	$(SRC)/lte/doc/source/figures/MCS_13_16.png \
	$(SRC)/lte/doc/source/figures/MCS_17_20.pdf \
	$(SRC)/lte/doc/source/figures/MCS_17_20.png \
	$(SRC)/lte/doc/source/figures/MCS_21_24.pdf \
	$(SRC)/lte/doc/source/figures/MCS_21_24.png \
	$(SRC)/lte/doc/source/figures/MCS_25_28.pdf \
	$(SRC)/lte/doc/source/figures/MCS_25_28.png \
	$(SRC)/lte/doc/source/figures/MCS_29_29.pdf \
	$(SRC)/lte/doc/source/figures/MCS_29_29.png \
	$(SRC)/lte/doc/source/figures/MCS_2_test.png \
	$(SRC)/lte/doc/source/figures/MCS_2_test.pdf \
	$(SRC)/lte/doc/source/figures/MCS_12_test.png \
	$(SRC)/lte/doc/source/figures/MCS_12_test.pdf \
	$(SRC)/lte/doc/source/figures/MCS_16_test.png \
	$(SRC)/lte/doc/source/figures/MCS_16_test.pdf \
	$(SRC)/lte/doc/source/figures/miesm_scheme.pdf \
	$(SRC)/lte/doc/source/figures/miesm_scheme.png \
	$(SRC)/lte/doc/source/figures/carrier-aggregation-impact.pdf \

=== ns-3.28/src/internet/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
import os
import sys

from waflib import Options, Logs, Utils, Task


# Required NSC version
NSC_RELEASE_NAME = "nsc-0.5.3"


def options(opt):
    opt.add_option('--with-nsc',
                   help=('Use Network Simulation Cradle, given by the indicated path,'
                         ' to allow the use of real-world network stacks'),
                   default='', dest='with_nsc')
    opt.add_option('--disable-nsc',
                   help=('Disable Network Simulation Cradle support'),
                   dest='disable_nsc', default=False, action="store_true")

def configure(conf):
    conf.env['ENABLE_NSC'] = False

    if Options.options.disable_nsc:
        conf.report_optional_feature("nsc", "Network Simulation Cradle", False,
                                     "disabled by user request")
        return

    # checks for flex and bison, which is needed to build NSCs globaliser
    # TODO: how to move these checks into the allinone scripts?
    #def check_nsc_buildutils():
    #    import flex
    #    import bison
    #    conf.check_tool('flex bison')
    #    conf.check(lib='fl', mandatory=True)

    # Check for the location of NSC
    lib_to_check = 'liblinux2.6.26.so'
    if Options.options.with_nsc:
        if os.path.isdir(Options.options.with_nsc):
            conf.msg("Checking for NSC location", ("%s (given)" % Options.options.with_nsc))
            conf.env['WITH_NSC'] = os.path.abspath(Options.options.with_nsc)
    else:
        # bake.py uses ../../build, while ns-3-dev uses ../nsc,
        # and ns-3 release uses ../NSC_RELEASE_NAME
        nsc_bake_build_dir = os.path.join('..', '..', 'build')
        nsc_bake_lib_dir = os.path.join(nsc_bake_build_dir, 'lib')
        nsc_dir = os.path.join('..', "nsc")
        nsc_release_dir = os.path.join('..', NSC_RELEASE_NAME)
        if os.path.exists(os.path.join(nsc_bake_lib_dir, lib_to_check)):
            conf.msg("Checking for NSC location",("%s (guessed)" % nsc_bake_build_dir))
            conf.env['WITH_NSC'] = os.path.abspath(nsc_bake_build_dir)
        elif os.path.isdir(nsc_dir):
            conf.msg("Checking for NSC location",("%s (guessed)" % nsc_dir))
            conf.env['WITH_NSC'] = os.path.abspath(nsc_dir)
        elif os.path.isdir(nsc_release_dir):
            conf.msg("Checking for NSC location", ("%s (guessed)" % nsc_release_dir))
            conf.env['WITH_NSC'] = os.path.abspath(nsc_release_dir)
        del nsc_bake_build_dir
        del nsc_bake_lib_dir
        del nsc_dir
        del nsc_release_dir

    if not conf.env['WITH_NSC']:
        conf.msg("Checking for NSC location", False)
        conf.report_optional_feature("nsc", "Network Simulation Cradle", False,
                                     "NSC not found (see option --with-nsc)")
        return
    
    if Options.platform in ['linux', 'freebsd']:
        arch = os.uname()[4]
    else:
        arch = None
    ok = False
    if arch in ('amd64', 'x86_64', 'i686', 'i586', 'i486', 'i386'):
        conf.env['NSC_ENABLED'] = True
        conf.env.append_value('CXXDEFINES', 'NETWORK_SIMULATION_CRADLE')
        conf.check_nonfatal(mandatory=True, lib='dl', define_name='HAVE_DL', uselib_store='DL')
        ok = True
    conf.msg('Checking for NSC supported architecture ' + (arch or ''), ok)
    
    if not ok:
        conf.env['NSC_ENABLED'] = False
        conf.report_optional_feature("nsc", "Network Simulation Cradle", False,
                                     "architecture %r not supported" % arch)
        return

    found = False
    for path in ['.', 'lib', 'lib64', 'linux-2.6.26']:
        if os.path.exists(os.path.join(conf.env['WITH_NSC'], path, lib_to_check)):
            # append the NSC kernel dir to the module path so that this dir
            # will end up in the LD_LIBRARY_PATH, thus allowing the NSC NS-3
            # module to find the necessary NSC shared libraries.
            found = True
            conf.env.append_value('NS3_MODULE_PATH',
                                  os.path.abspath(os.path.join(conf.env['WITH_NSC'], path)))
    if not found:
        conf.env['NSC_ENABLED'] = False
        conf.report_optional_feature("nsc", "Network Simulation Cradle", False,
                                     "NSC library %s is missing: NSC has not been built?" % lib_to_check)
    else:
        conf.report_optional_feature("nsc", "Network Simulation Cradle", True, "")


def build(bld):
    # bridge and mpi dependencies are due to global routing
    obj = bld.create_ns3_module('internet', ['bridge', 'mpi', 'traffic-control', 'network', 'core'])
    obj.source = [
        'model/ip-l4-protocol.cc',
        'model/udp-header.cc',
        'model/tcp-header.cc',
        'model/ipv4-interface.cc',
        'model/ipv4-l3-protocol.cc',
        'model/ipv4-end-point.cc',
        'model/udp-l4-protocol.cc',
        'model/tcp-l4-protocol.cc',
        'model/arp-header.cc',
        'model/arp-cache.cc',
        'model/arp-l3-protocol.cc',
        'model/udp-socket-impl.cc',
        'model/ipv4-end-point-demux.cc',
        'model/udp-socket-factory-impl.cc',
        'model/tcp-socket-factory-impl.cc',
        'model/pending-data.cc',
        'model/rtt-estimator.cc',
        'model/ipv4-raw-socket-factory-impl.cc',
        'model/ipv4-raw-socket-impl.cc',
        'model/icmpv4.cc',
        'model/icmpv4-l4-protocol.cc',
        'model/loopback-net-device.cc',
        'model/ndisc-cache.cc',
        'model/ipv6-interface.cc',
        'model/icmpv6-header.cc',
        'model/ipv6-l3-protocol.cc',
        'model/ipv6-end-point.cc',
        'model/ipv6-end-point-demux.cc',
        'model/ipv6-raw-socket-factory-impl.cc',
        'model/ipv6-raw-socket-impl.cc',
        'model/ipv6-autoconfigured-prefix.cc',
        'model/ipv6-extension.cc',
        'model/ipv6-extension-header.cc',
        'model/ipv6-extension-demux.cc',
        'model/ipv6-option.cc',
        'model/ipv6-option-header.cc',
        'model/ipv6-option-demux.cc',
        'model/icmpv6-l4-protocol.cc',
        'model/tcp-socket-base.cc',
        'model/tcp-highspeed.cc',
        'model/tcp-hybla.cc',
        'model/tcp-vegas.cc',
        'model/tcp-congestion-ops.cc',
        'model/tcp-westwood.cc',
        'model/tcp-scalable.cc', 
        'model/tcp-veno.cc',
        'model/tcp-bic.cc',
        'model/tcp-yeah.cc',
        'model/tcp-ledbat.cc',
        'model/tcp-illinois.cc',
        'model/tcp-htcp.cc',
        'model/tcp-lp.cc',
        'model/tcp-rx-buffer.cc',
        'model/tcp-tx-buffer.cc',
        'model/tcp-option.cc',
        'model/tcp-option-rfc793.cc',
        'model/tcp-option-winscale.cc',
        'model/tcp-option-ts.cc',
        'model/tcp-option-sack-permitted.cc',
        'model/tcp-option-sack.cc',
        'model/ipv4-packet-info-tag.cc',
        'model/ipv6-packet-info-tag.cc',
        'model/ipv4-interface-address.cc',
        'model/ipv4-address-generator.cc',
        'model/ipv4-header.cc',
        'model/ipv4-queue-disc-item.cc',
        'model/ipv4-packet-filter.cc',
        'model/ipv4-route.cc',
        'model/ipv4-routing-protocol.cc',
        'model/udp-socket.cc',
        'model/udp-socket-factory.cc',
        'model/tcp-socket.cc',
        'model/tcp-socket-factory.cc',
        'model/ipv4.cc',
        'model/ipv4-raw-socket-factory.cc',
        'model/ipv6-header.cc',
        'model/ipv6-queue-disc-item.cc',
        'model/ipv6-packet-filter.cc',
        'model/ipv6-interface-address.cc',
        'model/ipv6-route.cc',
        'model/ipv6.cc',
        'model/ipv6-raw-socket-factory.cc',
        'model/ipv6-routing-protocol.cc',
        'model/ipv4-list-routing.cc',
        'model/ipv6-list-routing.cc',
        'helper/ipv4-list-routing-helper.cc',
        'helper/ipv6-list-routing-helper.cc',
        'model/ipv4-static-routing.cc',
        'model/ipv4-routing-table-entry.cc',
        'model/ipv6-static-routing.cc',
        'model/ipv6-routing-table-entry.cc',
        'helper/ipv4-static-routing-helper.cc',
        'helper/ipv6-static-routing-helper.cc',
        'model/global-router-interface.cc',
        'model/global-route-manager.cc',
        'model/global-route-manager-impl.cc',
        'model/candidate-queue.cc',
        'model/ipv4-global-routing.cc',
        'helper/ipv4-global-routing-helper.cc',
        'helper/internet-stack-helper.cc',
        'helper/internet-trace-helper.cc',
        'helper/ipv4-address-helper.cc',
        'helper/ipv4-interface-container.cc',
        'helper/ipv4-routing-helper.cc',
        'helper/ipv6-address-helper.cc',
        'helper/ipv6-interface-container.cc',
        'helper/ipv6-routing-helper.cc',
        'model/ipv6-address-generator.cc',
        'model/ipv4-packet-probe.cc',
        'model/ipv6-packet-probe.cc',
        'model/ipv6-pmtu-cache.cc',
        'model/ripng.cc',
        'model/ripng-header.cc',
        'helper/ripng-helper.cc',
        'model/rip.cc',
        'model/rip-header.cc',
        'helper/rip-helper.cc',
        ]

    internet_test = bld.create_ns3_module_test_library('internet')
    internet_test.source = [
        'test/global-route-manager-impl-test-suite.cc',
        'test/ipv4-address-generator-test-suite.cc',
        'test/ipv4-address-helper-test-suite.cc',
        'test/ipv4-list-routing-test-suite.cc',
        'test/ipv4-packet-info-tag-test-suite.cc',
        'test/ipv4-raw-test.cc',
        'test/ipv4-header-test.cc',
        'test/ipv4-fragmentation-test.cc',
        'test/ipv4-forwarding-test.cc',
        'test/ipv4-test.cc',
        'test/ipv4-static-routing-test-suite.cc',
        'test/ipv4-global-routing-test-suite.cc',
        'test/ipv6-extension-header-test-suite.cc',
        'test/ipv6-list-routing-test-suite.cc',
        'test/ipv6-packet-info-tag-test-suite.cc',
        'test/ipv6-test.cc',
        'test/ipv6-raw-test.cc',
        'test/tcp-test.cc',
        'test/tcp-timestamp-test.cc',
        'test/tcp-sack-permitted-test.cc',
        'test/tcp-wscaling-test.cc',
        'test/tcp-option-test.cc',
        'test/tcp-header-test.cc',
        'test/tcp-general-test.cc',
        'test/tcp-error-model.cc',
        'test/tcp-slow-start-test.cc',
        'test/tcp-cong-avoid-test.cc',
        'test/tcp-fast-retr-test.cc',
        'test/tcp-rto-test.cc',
        'test/tcp-highspeed-test.cc',
        'test/tcp-hybla-test.cc',
        'test/tcp-vegas-test.cc',
        'test/tcp-scalable-test.cc',
        'test/tcp-veno-test.cc',
        'test/tcp-bic-test.cc',
        'test/tcp-yeah-test.cc',
        'test/tcp-illinois-test.cc',
        'test/tcp-htcp-test.cc',
        'test/tcp-lp-test.cc',
        'test/tcp-ledbat-test.cc',
        'test/tcp-zero-window-test.cc',
        'test/tcp-pkts-acked-test.cc',
        'test/tcp-rtt-estimation.cc',
        'test/tcp-bytes-in-flight-test.cc',
        'test/tcp-advertised-window-test.cc',
        'test/udp-test.cc',
        'test/ipv6-address-generator-test-suite.cc',
        'test/ipv6-dual-stack-test-suite.cc',
        'test/ipv6-fragmentation-test.cc',
        'test/ipv6-forwarding-test.cc',
        'test/ipv6-ripng-test.cc',
        'test/ipv6-address-helper-test-suite.cc',
        'test/rtt-test.cc',
        'test/tcp-tx-buffer-test.cc',
        'test/tcp-rx-buffer-test.cc',
        'test/tcp-endpoint-bug2211.cc',
        'test/tcp-datasentcb-test.cc',
        'test/ipv4-rip-test.cc',
        'test/tcp-close-test.cc',
        ]
    privateheaders = bld(features='ns3privateheader')
    privateheaders.module = 'internet'
    privateheaders.source = [
        ]
    headers = bld(features='ns3header')
    headers.module = 'internet'
    headers.source = [
        'model/udp-header.h',
        'model/tcp-header.h',
        'model/tcp-option.h',
        'model/tcp-option-winscale.h',
        'model/tcp-option-ts.h',
        'model/tcp-option-sack-permitted.h',
        'model/tcp-option-sack.h',

=== ns-3.28/src/traffic-control/wscript ===
# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

# def options(opt):
#     pass

# def configure(conf):
#     conf.check_nonfatal(header_name='stdint.h', define_name='HAVE_STDINT_H')

def build(bld):
    module = bld.create_ns3_module('traffic-control', ['core', 'network'])
    module.source = [
      'model/traffic-control-layer.cc',
      'model/packet-filter.cc',
      'model/queue-disc.cc',
      'model/pfifo-fast-queue-disc.cc',
      'model/fifo-queue-disc.cc',
      'model/red-queue-disc.cc',
      'model/codel-queue-disc.cc',
      'model/fq-codel-queue-disc.cc',
      'model/pie-queue-disc.cc',
      'model/mq-queue-disc.cc',
      'model/tbf-queue-disc.cc',
      'helper/traffic-control-helper.cc',
      'helper/queue-disc-container.cc'
        ]

    module_test = bld.create_ns3_module_test_library('traffic-control')
    module_test.source = [
      'test/red-queue-disc-test-suite.cc',
      'test/codel-queue-disc-test-suite.cc',
      'test/adaptive-red-queue-disc-test-suite.cc',
      'test/pie-queue-disc-test-suite.cc',
      'test/fifo-queue-disc-test-suite.cc',
      'test/tbf-queue-disc-test-suite.cc',
      'test/tc-flow-control-test-suite.cc'
        ]

    headers = bld(features='ns3header')
    headers.module = 'traffic-control'
    headers.source = [
      'model/traffic-control-layer.h',
      'model/packet-filter.h',
      'model/queue-disc.h',
      'model/pfifo-fast-queue-disc.h',
      'model/fifo-queue-disc.h',
      'model/red-queue-disc.h',
      'model/codel-queue-disc.h',
      'model/fq-codel-queue-disc.h',
      'model/pie-queue-disc.h',
      'model/mq-queue-disc.h',
      'model/tbf-queue-disc.h',
      'helper/traffic-control-helper.h',
      'helper/queue-disc-container.h'
        ]

    if bld.env.ENABLE_EXAMPLES:
        bld.recurse('examples')

    bld.ns3_python_bindings()

=== ns-3.28/src/wifi/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_module('wifi', ['network', 'propagation', 'energy', 'spectrum', 'antenna', 'mobility'])
    obj.source = [
        'model/wifi-utils.cc',
        'model/wifi-information-element.cc',
        'model/wifi-information-element-vector.cc',
        'model/wifi-mode.cc',
        'model/ssid.cc',
        'model/wifi-phy.cc',
        'model/wifi-phy-state-helper.cc',
        'model/error-rate-model.cc',
        'model/yans-error-rate-model.cc',
        'model/nist-error-rate-model.cc',
        'model/dsss-error-rate-model.cc',
        'model/interference-helper.cc',
        'model/yans-wifi-phy.cc',
        'model/yans-wifi-channel.cc',
        'model/spectrum-wifi-phy.cc',
        'model/wifi-phy-tag.cc',
        'model/wifi-spectrum-phy-interface.cc',
        'model/wifi-spectrum-signal-parameters.cc',
        'model/wifi-mac-header.cc',
        'model/wifi-mac-trailer.cc',
        'model/mac-low.cc',
        'model/mac-low-transmission-parameters.cc',
        'model/wifi-mac-queue.cc',
        'model/mac-tx-middle.cc',
        'model/mac-rx-middle.cc',
        'model/dca-txop.cc',
        'model/supported-rates.cc',
        'model/capability-information.cc',
        'model/status-code.cc',
        'model/mgt-headers.cc',
        'model/dcf-manager.cc',
        'model/dcf-state.cc',
        'model/wifi-mac.cc',
        'model/regular-wifi-mac.cc',
        'model/wifi-remote-station-manager.cc',
        'model/ap-wifi-mac.cc',
        'model/sta-wifi-mac.cc',
        'model/adhoc-wifi-mac.cc',
        'model/wifi-net-device.cc',
        'model/arf-wifi-manager.cc',
        'model/aarf-wifi-manager.cc',
        'model/ideal-wifi-manager.cc',
        'model/constant-rate-wifi-manager.cc',
        'model/amrr-wifi-manager.cc',
        'model/onoe-wifi-manager.cc',
        'model/rraa-wifi-manager.cc',
        'model/aarfcd-wifi-manager.cc',
        'model/cara-wifi-manager.cc',
        'model/minstrel-wifi-manager.cc',
        'model/minstrel-ht-wifi-manager.cc',
        'model/qos-utils.cc',
        'model/edca-txop-n.cc',
        'model/msdu-aggregator.cc',
        'model/amsdu-subframe-header.cc',
        'model/originator-block-ack-agreement.cc',
        'model/ctrl-headers.cc',
        'model/qos-blocked-destinations.cc',
        'model/block-ack-agreement.cc',
        'model/block-ack-manager.cc',
        'model/block-ack-cache.cc',
        'model/snr-tag.cc',
        'model/ht-capabilities.cc',
        'model/wifi-tx-vector.cc',
        'model/parf-wifi-manager.cc',
        'model/aparf-wifi-manager.cc',
        'model/rrpaa-wifi-manager.cc',
        'model/ampdu-subframe-header.cc',
        'model/mpdu-aggregator.cc',
        'model/ampdu-tag.cc',
        'model/wifi-radio-energy-model.cc',
        'model/wifi-tx-current-model.cc',
        'model/vht-capabilities.cc',
        'model/erp-information.cc',
        'model/ht-operation.cc',
        'model/vht-operation.cc',
        'model/dsss-parameter-set.cc',
        'model/edca-parameter-set.cc',
        'model/he-capabilities.cc',
        'model/frame-capture-model.cc',
        'model/simple-frame-capture-model.cc',
        'model/he-operation.cc',
        'model/extended-capabilities.cc',
        'helper/wifi-radio-energy-model-helper.cc',
        'helper/athstats-helper.cc',
        'helper/wifi-helper.cc',
        'helper/yans-wifi-helper.cc',
        'helper/spectrum-wifi-helper.cc',
        'helper/wifi-mac-helper.cc',
        'model/wifi-mac-queue-item.cc',
        ]

    obj_test = bld.create_ns3_module_test_library('wifi')
    obj_test.source = [
        'test/block-ack-test-suite.cc',
        'test/dcf-manager-test.cc',
        'test/tx-duration-test.cc',
        'test/power-rate-adaptation-test.cc',
        'test/wifi-test.cc',
        'test/spectrum-wifi-phy-test.cc',
        'test/wifi-aggregation-test.cc',
        'test/wifi-error-rate-models-test.cc',
        'test/wifi-transmit-mask-test.cc',
        ]

    headers = bld(features='ns3header')
    headers.module = 'wifi'
    headers.source = [
        'model/wifi-utils.h',
        'model/wifi-information-element.h',
        'model/wifi-information-element-vector.h',
        'model/wifi-net-device.h',
        'model/wifi-mode.h',
        'model/ssid.h',
        'model/wifi-preamble.h',
        'model/wifi-phy-standard.h',
        'model/yans-wifi-phy.h',
        'model/spectrum-wifi-phy.h',
        'model/wifi-phy-tag.h',
        'model/yans-wifi-channel.h',
        'model/wifi-phy.h',
        'model/wifi-spectrum-phy-interface.h',
        'model/wifi-spectrum-signal-parameters.h',
        'model/interference-helper.h',
        'model/wifi-remote-station-manager.h',
        'model/ap-wifi-mac.h',
        'model/sta-wifi-mac.h',
        'model/adhoc-wifi-mac.h',
        'model/arf-wifi-manager.h',
        'model/aarf-wifi-manager.h',
        'model/ideal-wifi-manager.h',
        'model/constant-rate-wifi-manager.h',
        'model/amrr-wifi-manager.h',
        'model/onoe-wifi-manager.h',
        'model/rraa-wifi-manager.h',
        'model/aarfcd-wifi-manager.h',
        'model/cara-wifi-manager.h',
        'model/minstrel-wifi-manager.h',
        'model/minstrel-ht-wifi-manager.h',
        'model/wifi-mac.h',
        'model/regular-wifi-mac.h',
        'model/supported-rates.h',
        'model/error-rate-model.h',
        'model/yans-error-rate-model.h',
        'model/nist-error-rate-model.h',
        'model/dsss-error-rate-model.h',
        'model/wifi-mac-queue.h',
        'model/dca-txop.h',
        'model/wifi-mac-header.h',
        'model/wifi-mac-trailer.h',
        'model/wifi-phy-state-helper.h',
        'model/qos-utils.h',
        'model/edca-txop-n.h',
        'model/msdu-aggregator.h',
        'model/amsdu-subframe-header.h',
        'model/mgt-headers.h',
        'model/status-code.h',
        'model/capability-information.h',
        'model/dcf-manager.h',
        'model/dcf-state.h',
        'model/mac-tx-middle.h', 
        'model/mac-rx-middle.h', 
        'model/mac-low.h',
        'model/mac-low-transmission-parameters.h',
        'model/originator-block-ack-agreement.h',
        'model/ctrl-headers.h',
        'model/block-ack-agreement.h',
        'model/block-ack-manager.h',
        'model/block-ack-cache.h',
        'model/snr-tag.h',
        'model/ht-capabilities.h',
        'model/parf-wifi-manager.h',
        'model/aparf-wifi-manager.h',
        'model/rrpaa-wifi-manager.h',
        'model/wifi-tx-vector.h',
        'model/ampdu-subframe-header.h',
        'model/mpdu-aggregator.h',
        'model/ampdu-tag.h',
        'model/wifi-radio-energy-model.h',
        'model/wifi-tx-current-model.h',
        'model/vht-capabilities.h',
        'model/erp-information.h',
        'model/ht-operation.h',
        'model/vht-operation.h',
        'model/dsss-parameter-set.h',
        'model/edca-parameter-set.h',
        'model/he-capabilities.h',
        'model/frame-capture-model.h',
        'model/simple-frame-capture-model.h',
        'model/qos-blocked-destinations.h',
        'model/he-operation.h',
        'model/extended-capabilities.h',
        'helper/wifi-radio-energy-model-helper.h',
        'helper/athstats-helper.h',
        'helper/wifi-helper.h',
        'helper/yans-wifi-helper.h',
        'helper/spectrum-wifi-helper.h',
        'helper/wifi-mac-helper.h',
        'model/wifi-mac-queue-item.h',
        'model/wifi-phy-state.h',
        'model/wifi-phy-listener.h',
        ]

    if bld.env['ENABLE_GSL']:
        obj.use.extend(['GSL', 'GSLCBLAS', 'M'])
        obj_test.use.extend(['GSL', 'GSLCBLAS', 'M'])

    if (bld.env['ENABLE_EXAMPLES']):
        bld.recurse('examples')

    bld.ns3_python_bindings()

=== ns-3.28/src/wifi/examples/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    if not bld.env['ENABLE_EXAMPLES']:
        return;

    obj = bld.create_ns3_program('wifi-phy-test',
        ['core', 'mobility', 'network', 'wifi'])
    obj.source = 'wifi-phy-test.cc'

    obj = bld.create_ns3_program('test-interference-helper',
        ['core', 'mobility', 'network', 'wifi'])
    obj.source = 'test-interference-helper.cc'

    obj = bld.create_ns3_program('wifi-manager-example',
        ['core', 'network', 'wifi', 'stats', 'mobility', 'propagation'])
    obj.source = 'wifi-manager-example.cc'

    obj = bld.create_ns3_program('wifi-trans-example',
        ['core', 'mobility', 'spectrum', 'wifi'])
    obj.source = 'wifi-trans-example.cc'

=== debian/changelog ===
ns3 (3.28+dfsg-2) unstable; urgency=medium

  * Fix a FTBFS on Hurd, where we cannot remove files that don't exist.
  * Fix a FTBFS on non-linux: don't install the linux-specific files.

 -- Martin Quinson <mquinson@debian.org>  Sun, 24 Jun 2018 16:13:11 +0200

ns3 (3.28+dfsg-1) unstable; urgency=medium

  * New upstream release (see /usr/share/doc/ns3/RELEASE_NOTES.gz).
  * Set myself as a maintainer: our alioth mailing list is dead.
    (Closes: #899619).
  * Bump the standard version to 4.1.4 (no change due)
    - We still have a get-orig-source but it's using uscan as requested
  * d/control: Point the VCS to salsa now that I migrated.

 -- Martin Quinson <mquinson@debian.org>  Sun, 24 Jun 2018 00:34:27 +0200

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 4.1.4
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders: YunQiang Su <syq@debian.org>
Build-Depends:
 bison,
 debhelper (>= 9),
 dh-exec (>= 0.13),
 dh-python,
 dpkg (>= 1.16.1),
 flex,
 libboost-filesystem-dev,
 libboost-signals-dev,
 libgraphviz-dev,
 libgsl-dev,
 libopenmpi-dev [alpha amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc sparc],
 libsqlite3-dev,
 libxml2-dev,
 pkg-config,
 python-dev,
 python-pygraphviz,
 quilt (>= 0.46-7~),
# Only used for NetAnim: qt4-dev-tools, qt4-qmake, libqt4-dev,
Build-Depends-Indep:
 dia,
 ghostscript,
 imagemagick,
 python-sphinx,
 texlive-font-utils,
 texlive-latex-extra,
 texlive-latex-base,
 texlive-latex-recommended,
Build-Conflicts:
 libmpich2-dev,
Vcs-git: https://salsa.debian.org/debian/ns3.git
Vcs-Browser: https://salsa.debian.org/debian/ns3
Homepage: http://www.nsnam.org/

Package: ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: discrete-event network simulator for Internet systems
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and NAM (network animator). 
 .
 This package contains several utilities. The files for development
 are in libns3-3, libns3-dev and python-ns3.

Package: ns3-doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
Section: doc
Description: documentation for ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and NAM (network animator). 
 .
 This package contains manual, modules, tutorial and doxygen.

Package: libns3-3v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: shared libraries of ns-3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and NAM (network animator). 
 .
 This package contains shared libraries.

Package: libns3-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libns3-3v5 (= ${binary:Version}), 
  g++
Breaks: ns3 (= 3.25+dfsg2-2)
Section: libdevel
Description: Static and header files of ns-3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and NAM (network animator). 
 .
 This package contains static libraries, header files.

Package: python-ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
  python-pygraphviz
Section: python
Suggests: python-kiwi, tcpdump
Description: Python binding of ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and NAM (network animator). 
 .
 This package contains Python binding of ns3.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
LDFLAGS+=-Wl,--as-needed

TOPDIR=$(shell pwd)
NS3_DIR=$(shell ls -d ns-*)
PYBINDGENV_DIR=$(shell ls -d pybindgen-*)

# Build in parallel, unless there is less than 3GiB
MEMORY=$(shell awk '/MemTotal:/{print $$2}' /proc/meminfo)
CPU_CORES=$(shell nproc)
BUILD_OPTION=$(shell if [ $(MEMORY) -lt 3090252 ]; then echo "-j1"; else echo "-j$(CPU_CORES)"; fi)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Reproducible Build wants us to use always the same date when building the documentation
include /usr/share/dpkg/pkg-info.mk
SPHINXOPTS := -D today=\"$(SOURCE_DATE_EPOCH)\"
SPHINXOPTS += -D html_last_updated_fmt=\"$(SOURCE_DATE_EPOCH)\"

%:
	dh $@ --with python2

build-indep: build-doc-stamp

build-doc-stamp:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	make html man -C ./$(NS3_DIR)/doc/manual/ SPHINXOPTS="$(SPHINXOPTS)"
	make html man -C ./$(NS3_DIR)/doc/models/ SPHINXOPTS="$(SPHINXOPTS)"
	make html man -C ./$(NS3_DIR)/doc/tutorial/ SPHINXOPTS="$(SPHINXOPTS)"
else
	mkdir -p ./$(NS3_DIR)/doc/manual/build/html
	mkdir -p ./$(NS3_DIR)/doc/models/build/html
	mkdir -p ./$(NS3_DIR)/doc/tutorial/build/html
endif
	rm -f ns-3.*/doc/*/build/*/_static/jquery.js
	rm -f ns-3.*/doc/*/build/*/_static/underscore.js
	touch $@

override_dh_auto_configure:
	cd $(NS3_DIR) ; ./waf configure \
	           --prefix=/usr --enable-mpi -d release -o build-shared \
	           --libexecdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	           --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build:
	####### build and install shared libraries, python bindings for default python.
	cd $(NS3_DIR) ; ./waf build $(BUILD_OPTION)

	cd ./$(NS3_DIR); ./waf install --destdir=../debian/tmp
	# delete test of modules but not libns3.${ver}-test.so which seems used
	# MQ: it seems that these test modules does not exist anymore in v3.27
	# MQ: so only remove them if they exist
	test -e debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ && ls debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libns3*-*-test.so*|rm -fv
	# cp netanim-*/NetAnim debian/tmp/usr/bin
	# Install my own little script as a compiler
	cp debian/ns3++ debian/tmp/usr/bin
	chmod +x debian/tmp/usr/bin/ns3++
	
override_dh_auto_test:
	-cd ./$(NS3_DIR); ./test.py -v

override_dh_prep:
	#I install files here when build.
	#The upstream cannot work well for us.
	#I will remove this dir when dh_clean, surely.
	dh_prep -Xdebian/tmp
	
override_dh_python2:
	#### upstream now can only build for the default version of python.
	dh_python2 --no-guessing-versions

override_dh_installchangelogs:
	dh_installchangelogs ./$(NS3_DIR)/CHANGES.html

override_dh_auto_clean:
	#-sh ./debian/clean-tree.sh
	dh_auto_clean

override_dh_compress:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_compress -Xusr/share/doc/ns3/examples/  -Xusr/share/doc/ns3/manual/  -Xusr/share/doc/ns3/models/  -Xusr/share/doc/ns3/tutorial/
endif

override_dh_builddeb:
	dh_builddeb -- -Zxz

update-patches:
	cd debian/patches; \
	sed -i 's#ns-3.[0-9]*#$(NS3_DIR)#g' *.diff

get-orig-source:
	uscan --verbose --force-download
